<?php

namespace Drupal\off_canvas_menu\Menu;

use Drupal\Core\Menu\MenuTreeParameters;
use Drupal\Core\Menu\MenuLinkTreeInterface;

class MenuService {
    protected $linkTree;

    public function __construct(MenuLinkTreeInterface $linkTree) {
        $this->linkTree = $linkTree;
    }

    public function buildMenu($menu_name) {
        $parameters = new MenuTreeParameters();
        $tree = $this->linkTree->load($menu_name, $parameters);

        // Apply menu link access checks and sorting
        $manipulated = $this->linkTree->transform($tree, []);

        // Now build the render array from the processed tree
        return $this->linkTree->build($manipulated);
    }
}
